# -*- coding: utf-8 -*-
"""
Created on Mon Jun 01 10:12:24 2015

@author: Matthias
"""
#Working along CDppWinUSB::Initialize_Device!!!!!!!!!!!!!!!!!!!!!!

import ctypes
import win32file
import struct
import numpy as np
import time
#import win32api
#import win32con


# class combineints_class():
#     def __init__(self):
#         pass
#     def combineints(self,*args):
#         """
#         given the bytes of a multi byte number combine into one
#         pass them in least to most significant 
#         """
#     #    print type(args),args
#         ans = 0
#         if type(args) == int:
#             for i, val in enumerate(args):
#                 ans += (val << i*8)
#         elif type(args) == tuple:
#             for i, val in enumerate(args[0]):
#         #        print i, val
#                 ans += (val << i*8)
#         return ans
    

class Amptek_SDD():

    #Definition of classes
    def combineints(self,*args):
        """
        given the bytes of a multi byte number combine into one
        pass them in least to most significant 
        """
    #    print type(args),args
        ans = 0
        if type(args) == int:
            for i, val in enumerate(args):
                ans += (val << i*8)
        elif type(args) == tuple:
            for i, val in enumerate(args[0]):
        #        print i, val
                ans += (val << i*8)
        return ans

    
    class Packet_MA(ctypes.Structure):
        _fields_ = [
            #package set to MCA
            ("SYNC1", ctypes.c_ubyte),
            ("SYNC2", ctypes.c_ubyte),
            ("PID1", ctypes.c_ubyte),
            ("PID2", ctypes.c_ubyte),
            ("LENMSB",  ctypes.c_ubyte),
            ("LENLSB",  ctypes.c_ubyte),
            ("DATA",  (ctypes.c_ubyte * 514)),
    #        ("CHKMSB",  ctypes.c_ubyte),
    #        ("CHKLSB",  ctypes.c_ubyte),
        ]
    
    
    class Packet_MA_in(ctypes.Structure):
        #Package read from MCA
        _fields_ = [
            ("SYNC1", ctypes.c_ubyte),
            ("SYNC2", ctypes.c_ubyte),
            ("PID1", ctypes.c_ubyte),
            ("PID2", ctypes.c_ubyte),
            ("LENMSB",  ctypes.c_ubyte),
            ("LENLSB",  ctypes.c_ubyte),
            ("DATA",  (ctypes.c_ubyte * 32768)),
            ("CHKMSB",  ctypes.c_ubyte),
            ("CHKLSB",  ctypes.c_ubyte),
        ]
    
    class WINUSB_PIPE_INTERFACE(ctypes.Structure):
        _fields_ = [
            ("bLength", ctypes.c_ubyte),
            ("bDescriptorType", ctypes.c_ubyte),
            ("bInterfaceNumber", ctypes.c_ubyte),
            ("bAlternateSetting", ctypes.c_ubyte),
            ("bNumEndpoints", ctypes.c_ubyte),
            ("bInterfaceClass", ctypes.c_ubyte),
            ("bInterfaceSubClass", ctypes.c_ubyte),
            ("bInterfaceProtocol", ctypes.c_ubyte),
            ("iInterface", ctypes.c_ubyte),
        ]
    
    
    class WINUSB_PIPE_INFORMATION(ctypes.Structure):
        _fields_ = [
            ("PipeType", ctypes.c_ulong),
            ("PipeId", ctypes.c_ubyte),
            ("MaximumPacketSize",  ctypes.c_ushort),
            ("Interval", ctypes.c_ubyte),
        ]
    
    class PD5Status(object):    
        def combineints(self,*args):
            """
            given the bytes of a multi byte number combine into one
            pass them in least to most significant 
            """
        #    print type(args),args
            ans = 0
            if type(args) == int:
                for i, val in enumerate(args):
                    ans += (val << i*8)
            elif type(args) == tuple:
                for i, val in enumerate(args[0]):
            #        print i, val
                    ans += (val << i*8)
            return ans

        def __init__(self, statdata):
            self.Fastcount=self.combineints(statdata[0:0+4])
            self.Slowcount=self.combineints(statdata[4:4+4])
            self.GPcount=self.combineints(statdata[8:8+4])
            self.Acctime=self.combineints(statdata[14:14+3])*0.1+statdata[13]*0.001
            self.TBD=self.combineints(statdata[16:16+4])
            self.Realtime=self.combineints(statdata[20:20+4])
            self.Firmware_version=str(statdata[24]>>4)+'.'+str(statdata[24]&15)
            self.FPGA_version=str(statdata[25]>>4)+'.'+str(statdata[25]&15)
            self.serialnumber=self.combineints(statdata[26:26+4])            
            # self.voltage=(struct.unpack('>h',(chr(statdata[30])+chr(statdata[31])))[0])*0.5
            # self.detectortemp=struct.unpack('>H',(chr(statdata[32])+chr(statdata[33])))[0]*.1
            # No idea how this ever worked...
            self.voltage=((statdata[30] << 8) | statdata[31])*.5
            self.detectortemp=((statdata[32] << 8) | statdata[33])*.1
            self.boardtemp=statdata[34]
            self.unit_configured=bool(2**1&statdata[35])
            self.oscill_ready=bool(2**2&statdata[35])
            self.gate_disabled=bool(2**3&statdata[35])
            self.count_reached=bool(2**4&statdata[35])
            self.mca_enabled=bool(2**5&statdata[35])
            self.afthreshold_locked=bool(2**6&statdata[35])
            self.Preset_RT_reached=bool(2**7&statdata[35])
            self.PD5present=bool(128&statdata[38])
            self.DEVICE_ID=int(statdata[39])
    
    
    #Definition of constants
    class cc():
        GENERIC_READ    = (-2147483648)
        GENERIC_WRITE   = (1073741824)
        FILE_SHARE_READ = 1
        FILE_SHARE_WRITE = 2
        OPEN_EXISTING   = 3
        FILE_FLAG_OVERLAPPED    = 1073741824
        SHORT_PACKET_TERMINATE  =ctypes.c_ubyte(int('0x01',0))
        AUTO_CLEAR_STALL        =ctypes.c_ubyte(int('0x02',0))
        PIPE_TRANSFER_TIMEOUT   =ctypes.c_ubyte(int('0x03',0))
        IGNORE_SHORT_PACKETS    =ctypes.c_ubyte(int('0x04',0))
        ALLOW_PARTIAL_READS     =ctypes.c_ubyte(int('0x05',0))
        AUTO_FLUSH              =ctypes.c_ubyte(int('0x06',0))
        RAW_IO                  =ctypes.c_ubyte(int('0x07',0))
        MAXIMUM_TRANSFER_SIZE   =ctypes.c_ubyte(int('0x08',0))
        pipeTimeout=ctypes.c_ulong(500)
        bTrue=ctypes.c_bool(True)
        bFalse=ctypes.c_bool(False)
        lens=450 #Length of string to detector    
        bTrue=ctypes.c_bool(True)
        bFalse=ctypes.c_bool(False)

    class cc_connect():
        PID='842A'
        VID='10C4'
        h=None
        winUSBHandle=None
    
    #Definition of functions
    def __init__(self, ident = None):
        self.ident = ident
    

        
    def calc_checksum(self,packet):
        packet.SYNC1=int('0xF5',0)
        packet.SYNC2=int('0xFA',0)    
        dlen=self.combineints((packet.LENLSB,packet.LENMSB))
        tot=packet.SYNC1+packet.SYNC2+packet.PID1+packet.PID2+packet.LENMSB+packet.LENLSB+sum(packet.DATA[:])
        com=2**16-tot
        packet.DATA[dlen]=(com>>8)
        packet.DATA[dlen+1]=(com&255)
        return packet
    
    def set_argtypes(self):
        ctypes.windll.winusb.WinUsb_QueryPipe.argtypes=[ctypes.c_int64,ctypes.c_ubyte,ctypes.c_ubyte,ctypes.POINTER(self.WINUSB_PIPE_INFORMATION)]
        ctypes.windll.winusb.WinUsb_QueryDeviceInformation.argtypes=[ctypes.c_int64,ctypes.c_ubyte,ctypes.POINTER(ctypes.c_ulong),ctypes.POINTER(ctypes.c_ubyte)]
        ctypes.windll.winusb.WinUsb_SetPipePolicy.argtypes=[ctypes.c_int64,ctypes.c_ubyte,ctypes.c_ubyte,ctypes.c_int,ctypes.c_void_p]#ctypes.POINTER(ctypes.c_bool)]


        ctypes.windll.winusb.WinUsb_WritePipe.argtypes=[ctypes.c_int64, ctypes.c_ubyte, ctypes.c_void_p, ctypes.c_ulong, ctypes.POINTER(ctypes.c_ulong), ctypes.c_void_p]
        ctypes.windll.winusb.WinUsb_ReadPipe.argtypes=[ctypes.c_int64, ctypes.c_ubyte, ctypes.POINTER(self.Packet_MA_in),ctypes.c_ulong, ctypes.POINTER(ctypes.c_ulong), ctypes.c_void_p]
        ctypes.windll.winusb.WinUsb_Free.argtypes=[ctypes.c_int64,]
        ctypes.windll.kernel32.CloseHandle.argtypes=[ctypes.c_int64,]



    
    
    #Find Detector by PID and VID, connect to it and configure its pipes
    def connect(self,PID=None,VID=None):
        self.set_argtypes()
        if PID==None or VID==None:
            PID,VID=self.cc_connect.PID,self.cc_connect.VID
        lili=win32file.QueryDosDevice(None)
        lislis=lili.split('\x00')
        dev=filter(lambda x: PID in x and VID in x, lislis)
        dev=list(dev)
#        for d in dev: 
#            print d
#        print len(dev)
#        print type(dev)
        self.name='Amptek SDD'
        if len(dev) == 0:
            print('Detector not found')
            return False
        
        USB_ID=u'\\\?\\'+dev[0]
        winUSBHandle=ctypes.windll.kernel32.CreateFileW(USB_ID, self.cc.GENERIC_READ | self.cc.GENERIC_WRITE, self.cc.FILE_SHARE_READ | self.cc.FILE_SHARE_WRITE, None, self.cc.OPEN_EXISTING, self.cc.FILE_FLAG_OVERLAPPED, None)
        if winUSBHandle != -1:
            print( 'Connection successful to '+USB_ID)
        else:
            print( 'Connection failed to '+USB_ID)
            return False
        #Initialize USB device and read its parameters
        h = ctypes.c_void_p()
        ctypes.windll.winusb.WinUsb_Initialize(winUSBHandle, ctypes.byref(h))
        speed=ctypes.c_ubyte(0)
        length=ctypes.c_ulong(ctypes.sizeof(ctypes.c_ubyte))
        DEVICE_SPEED=ctypes.c_ubyte(1)
        res=ctypes.windll.winusb.WinUsb_QueryDeviceInformation(
            h.value, 
            DEVICE_SPEED, 
            ctypes.byref(length), 
            ctypes.byref(speed))
        
        if bool(res):
            print( 'Initialized '+USB_ID)
            print( 'DEVICE_SPEED, length, speed')
            print( DEVICE_SPEED.value, length.value, speed.value)
        else:
            print( 'Initialized failed')
            return False
        #Query the USB interface and configure the Pipes
        infdec=self.WINUSB_PIPE_INTERFACE()

        ctypes.windll.winusb.WinUsb_QueryInterfaceSettings.argtypes=[ctypes.c_int64,ctypes.c_int,ctypes.POINTER(self.WINUSB_PIPE_INTERFACE)]
        if ctypes.windll.winusb.WinUsb_QueryInterfaceSettings(h.value, 0, ctypes.byref(infdec)):
            print( 'Received Interface settings!')
        else:
            print( 'Receiving Interface settings failed!')
            return False
        
        aa=self.WINUSB_PIPE_INFORMATION()
        for i in range(infdec.bNumEndpoints):
            if ctypes.windll.winusb.WinUsb_QueryPipe(
                h.value, 
                ctypes.c_ubyte(0), 
                ctypes.c_ubyte(i),
                ctypes.byref(aa)):
        #            aa.PipeType,aa.PipeId,aa.MaximumPacketSize,aa.Interval
                    #Type 2 means that they are both BULK
                    # 2 & 128 (bitwise AND) is TRUE=> it is IN communication
                    #The interval is ignored, as they are bulk
                    if aa.PipeType == 2 and bool(aa.PipeId&128):
                        #Pipe_In=aa
                        res=1
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.IGNORE_SHORT_PACKETS, ctypes.sizeof(ctypes.c_ubyte), ctypes.byref(self.cc.bFalse));  
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.AUTO_CLEAR_STALL, ctypes.sizeof(ctypes.c_ubyte), ctypes.byref(self.cc.bTrue));    
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.ALLOW_PARTIAL_READS, ctypes.sizeof(ctypes.c_ubyte), ctypes.byref(self.cc.bFalse));    
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.PIPE_TRANSFER_TIMEOUT, ctypes.sizeof(ctypes.c_ulong), ctypes.byref(self.cc.pipeTimeout));
                        if res:
                            print( 'its an IN channel:')
                            print( (aa.PipeType,aa.PipeId,aa.MaximumPacketSize,aa.Interval))
                        else:
                            print( 'Querry Pipe failed at: '+str(i))
                    elif aa.PipeType == 2 and not bool(aa.PipeId&128):
                        #Pipe_Out=aa
                        res=1
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.IGNORE_SHORT_PACKETS,  ctypes.sizeof(ctypes.c_ubyte), ctypes.byref(self.cc.bFalse));  
                        # THIS IS A MA CHANGE,AS IT MAKES NO SENSE IN THE SOURCE CODE
                        #ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, SHORT_PACKET_TERMINATE, ctypes.sizeof(ctypes.c_ubyte), ctypes.byref(self.cc.bTrue));
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.SHORT_PACKET_TERMINATE, ctypes.sizeof(ctypes.c_ubyte), ctypes.byref(self.cc.bFalse));
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.AUTO_CLEAR_STALL, ctypes.sizeof(ctypes.c_ubyte), ctypes.byref(self.cc.bTrue));
                        res*=ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, aa.PipeId, self.cc.PIPE_TRANSFER_TIMEOUT, ctypes.sizeof(ctypes.c_ulong), ctypes.byref(self.cc.pipeTimeout));
                        if res:
                            print( 'its an OUT channel:')
                            print( (aa.PipeType,aa.PipeId,aa.MaximumPacketSize,aa.Interval))
                        else:
                            print( 'Querry Pipe failed at: '+str(i))
            else:
                print( 'Reding pipes failed!'  )  
                return False
        
        PIPE_TRANSFER_TIMEOUT   =int('0x03',0)
        if ctypes.windll.winusb.WinUsb_SetPipePolicy(h.value, ctypes.c_ubyte(129), PIPE_TRANSFER_TIMEOUT, ctypes.sizeof(ctypes.c_ulong), ctypes.byref(self.cc.pipeTimeout)):
            print( 'Set Transfer Timeout')
        else:
            print( 'Setting Transfer Timeout failed')
            return False
        self.cc_connect.h,self.cc_connect.winUSBHandle=h,winUSBHandle
        try:
            td=self.read_config()
            td=td[td.find('MCAC='):]
            td=td[0:td.find(';')]
            td=td[td.find('=')+1:]
            self.nchan=int(td)
        except:
            print('DETECTOR CONFIG NOT READ. NUMBER OF CHANNELS SET TO 2048! ')
            self.nchan=2048
        return True
            
#    h,winUSBHandle=connect(PID,VID)    
    
    
    
    
    #Loading package for requesting status
    def status(self,h=None):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.SYNC1,pam.SYNC2,pam.PID1,pam.PID2,pam.LENMSB,pam.LENLSB=int('0xF5',0),int('0xFA',0),int('0x01',0),int('0x01',0),int('0x00',0),int('0x00',0)
        pam=self.calc_checksum(pam)
        
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent'
        else:
            print( 'Package sent failed')
        
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Status read'
        else:
            print( 'Status read failed')
        
        statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
        sts=self.PD5Status(statdata)
        return sts
    
    def status_raw(self,h=None):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.SYNC1,pam.SYNC2,pam.PID1,pam.PID2,pam.LENMSB,pam.LENLSB=int('0xF5',0),int('0xFA',0),int('0x01',0),int('0x01',0),int('0x00',0),int('0x00',0)
        pam=self.calc_checksum(pam)
        
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent'
        else:
            print( 'Package sent failed')
        
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Status read'
        else:
            print( 'Status read failed')
        
        statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
#        sts=self.PD5Status(statdata)
        return statdata    
    
    
    
    def write_config(self, h=None,config_file=r'.\Amptek_configuration.txt'):
        if h == None:
            h=self.cc_connect.h
        #config_file=r'C:\Users\Matthias\Documents\Paris\scanner\amptek\DPPMCA\DET_CFG\DP5\SDD Default DP5.txt'
        #config_file=r'C:\Users\Matthias\Documents\Paris\scanner\amptek\DPPMCA\DET_CFG\DP5\SDD Low Energy Default DP5.txt'
        #config_file=r'C:\Users\Matthias\Documents\Paris\scanner\amptek\DPPMCA\DET_CFG\DP5\FastSDD Default DP5.txt'
        f=open(config_file)
        com_arr=f.readlines()
        f.close()
        unusedpara=['CON1','CON2','VOLU']#These are parameters for other versions of the DPP
        for j in unusedpara:
            for i,c in enumerate(com_arr):
                if c[:len(j)] == j:
                    com_arr.remove(c)
                    #print 'removed '+c
        commandm_write=''
        for i,c in enumerate(com_arr):
            if c[0] != '[':#CON2 is not parameter of PD5
                if c.find('=;') == -1 and c.find('RTDS=0') == -1 :#RTDS raises error is explictly set to 0
                    commandm_write+=c[:-1]
        #commandm="RESC=YES;CLCK=85;TPEA=9.622;GAIF=0.9313;GAIN=64.998;RESL=204;TFLA=0.200;TPFA=100;PURE=ON;RTDE=OFF;MCAS=NORM;MCAC=2048;SOFF=OFF;AINP=POS;INOF=DEF;GAIA=20;CUSP=0;PDMD=NORM;THSL=0.976;TLLD=OFF;THFA=41.43;DACO=SHAPED;DACF=50;RTDS=0;RTDT=0.00;BLRM=1;BLRD=3;BLRU=0;GATE=OFF;AUO1=SCA8;PRET=OFF;PRER=OFF;PREC=OFF;PRCL=1;PRCH=8191;HVSE=-110;TECS=220;PAPS=ON;SCOE=FALLING;SCOT=12;SCOG=1;MCSL=1;MCSH=8191;MCST=0.00;AUO2=ICR;TPMO=OFF;GPED=RISING;GPIN=AUX1;GPME=ON;GPGA=ON;GPMC=ON;MCAE=ON;VOLU=OFF;CON1=DAC;CON2=AUXOUT2;BOOT=ON;TPEA=9.600;GAIF=0.9313;GAIN=64.998;RESL=204;TFLA=0.200;SOFF=;INOF=;CUSP=0;THSL=0.976;TLLD=;THFA=41.43;DACO=;DACF=50;RTDS=0;RTDT=0.00;BLRD=3;BLRU=0;AUO1=;PRET=;PRER=;PREC=;PRCL=1;PRCH=8191;HVSE=-110;TECS=220;MCSL=1;MCSH=8191;MCST=0.00;AUO2=;GPIN=;"
        commandm_write+='RTDS=0;'#There seems to be no other means to set this to 0, then to provoc an error message...
        #send configuration
        lo=0
        for i in range(int(np.ceil(len(commandm_write)/self.cc.lens))):
            pam=self.Packet_MA()
        #    pam.SYNC1,pam.SYNC2=int('0xF5',0),int('0xFA',0)
            pam.PID1,pam.PID2=int('0x20',0),int(2)
            command=commandm_write[lo:commandm_write.find(';',(i+1)*self.cc.lens-15)]+';' 
            lo=commandm_write.find(';',(i+1)*self.cc.lens-15)+1
            b=bytearray()
            b.extend(command)
            pam.DATA[:len(b)]=b
            pam.LENMSB,pam.LENLSB=(len(b)>>8),(len(b)&255)
            pam=self.calc_checksum(pam)
            PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
            bytesWritten=ctypes.c_ulong(0)
            if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
                print( 'Package sent with bytes '+str(bytesWritten))
            else:
                print( 'Package sent failed')
            bytesWritten=ctypes.c_ulong(0)
            par=self.Packet_MA_in()
            if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
                if par.PID1==int('0xFF',0) and par.PID2==0:
                    print( 'Configuration written to detector, based on '+config_file)
                else:
                    print( 'Problem with command (RTDS error is normal)')
                    statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
                    b2=bytearray(len(statdata))
                    b2[:]=statdata[:]
                    print( par.PID1, par.PID2,b2)
            else:
                print( 'Status read failed')
        
    
    def read_config(self, h=None,config_file=r'.\Amptek_configuration.txt'):
        debug=True
        if h ==None:
            h=self.cc_connect.h
        #config_file=r'C:\Users\Matthias\Documents\Paris\scanner\amptek\DPPMCA\DET_CFG\DP5\SDD Default DP5.txt'
        #config_file=r'C:\Users\Matthias\Documents\Paris\scanner\amptek\DPPMCA\DET_CFG\DP5\SDD Low Energy Default DP5.txt'
        #config_file=r'C:\Users\Matthias\Documents\Paris\scanner\amptek\DPPMCA\DET_CFG\DP5\FastSDD Default DP5.txt'
        if debug:
            print('reading configuration from: '+config_file)
        f=open(config_file)
        com_arr=f.readlines()
        f.close()
        unusedpara=['CON1','CON2','VOLU']#These are parameters for other versions of the DPP
        for j in unusedpara:
            for i,c in enumerate(com_arr):
                if c[:len(j)] == j:
                    com_arr.remove(c)
                    #print 'removed '+c
        commandm_read=commandm_write=''
        for i,c in enumerate(com_arr):
            if c[0] != '[':#CON2 is not parameter of PD5
                if c.find('=;') == -1 and c.find('RTDS=0') == -1 :#RTDS raises error is explictly set to 0
                    commandm_write+=c[:-1]
        #commandm="RESC=YES;CLCK=85;TPEA=9.622;GAIF=0.9313;GAIN=64.998;RESL=204;TFLA=0.200;TPFA=100;PURE=ON;RTDE=OFF;MCAS=NORM;MCAC=2048;SOFF=OFF;AINP=POS;INOF=DEF;GAIA=20;CUSP=0;PDMD=NORM;THSL=0.976;TLLD=OFF;THFA=41.43;DACO=SHAPED;DACF=50;RTDS=0;RTDT=0.00;BLRM=1;BLRD=3;BLRU=0;GATE=OFF;AUO1=SCA8;PRET=OFF;PRER=OFF;PREC=OFF;PRCL=1;PRCH=8191;HVSE=-110;TECS=220;PAPS=ON;SCOE=FALLING;SCOT=12;SCOG=1;MCSL=1;MCSH=8191;MCST=0.00;AUO2=ICR;TPMO=OFF;GPED=RISING;GPIN=AUX1;GPME=ON;GPGA=ON;GPMC=ON;MCAE=ON;VOLU=OFF;CON1=DAC;CON2=AUXOUT2;BOOT=ON;TPEA=9.600;GAIF=0.9313;GAIN=64.998;RESL=204;TFLA=0.200;SOFF=;INOF=;CUSP=0;THSL=0.976;TLLD=;THFA=41.43;DACO=;DACF=50;RTDS=0;RTDT=0.00;BLRD=3;BLRU=0;AUO1=;PRET=;PRER=;PREC=;PRCL=1;PRCH=8191;HVSE=-110;TECS=220;MCSL=1;MCSH=8191;MCST=0.00;AUO2=;GPIN=;"
        commandm_write+='RTDS=0;'#There seems to be no other means to set this to 0, then to provoc an error message...
        commandm_read=commandm_write
        #read configuration
        conf_read=''
        lo=0
        for i in range(int(np.ceil(len(commandm_read)/self.cc.lens))):
            pam=self.Packet_MA()
        #    pam.SYNC1,pam.SYNC2=int('0xF5',0),int('0xFA',0)
            pam.PID1,pam.PID2=int('0x20',0),int(3)
            command=commandm_read[lo:commandm_read.find(';',(i+1)*450-15)]+';' 
            lo=commandm_read.find(';',(i+1)*450-15)+1
            b=bytearray()
            b.extend(command.encode('utf-8'))
            pam.DATA[:len(b)]=b
            pam.LENMSB,pam.LENLSB=(len(b)>>8),(len(b)&255)
            pam=self.calc_checksum(pam)
            PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
            bytesWritten=ctypes.c_ulong(0)
            if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
                pass
                #print 'Package sent with bytes '+str(bytesWritten)
            else:
                print ('Package sent failed')
            bytesWritten=ctypes.c_ulong(0)
            par=self.Packet_MA_in()
            if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
                pass
                #print 'Status read in bytes '+str(bytesWritten)
            else:
                print( 'Status read failed')
            statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
            b2=bytearray(len(statdata))
            b2[:]=statdata[:]
            conf_read+=b2.decode('utf-8')
        
        print( 'Configuration read: ') 
        print( conf_read)
        return conf_read
    
    
    #Disable MCA
    def disable_MCA(self, h=None):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.PID1,pam.PID2=int('0xF0',0),int(3)
        pam=self.calc_checksum(pam)
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
                #print 'Package sent with bytes '+str(bytesWritten)
        else:
            print( 'Package sent failed')
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
        else:
            print( 'Command failed')
    
    
    #Clear Spectrum
    def clear_spectrum(self, h=None):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.PID1,pam.PID2=int('0xF0',0),int(1)
        pam=self.calc_checksum(pam)
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent with bytes '+str(bytesWritten)
        else:
            print( 'Package sent failed')
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
        else:
            print( 'Command failed')
    
    #Enable MCA
    def enable_MCA(self,h=None):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.PID1,pam.PID2=int('0xF0',0),int(2)#request spectrum
        pam=self.calc_checksum(pam)
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent with bytes '+str(bytesWritten)
        else:
            print( 'Package sent failed')
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
        else:
            print( 'Command failed')
        
    
    
    def set_acctime(self,h=None,time=1):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.PID1,pam.PID2=int('0x20',0),int(2)
        command='PRER='+str(time)+';'
        b=bytearray()
        b.extend(command.encode('utf-8'))
        pam.DATA[:len(b)]=b
        pam.LENMSB,pam.LENLSB=(len(b)>>8),(len(b)&255)
        pam=self.calc_checksum(pam)
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent with bytes '+str(bytesWritten)
        else:
            print( 'Package sent failed')
        
        bytesWritten=ctypes.c_ulong(0)
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            if par.PID1==int('0xFF',0) and par.PID2==0:
                print( 'Configuration written' )
            else:
                statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
                b2=bytearray(len(statdata))
                b2[:]=statdata[:]
                print( par.PID1, par.PID2,b2)
        else:
            print ('Status read failed')
    
    
    
    
    def start_sweep(self,h=None,acctime=-1):
        if h ==None:
            h=self.cc_connect.h
        self.disable_MCA(h)
        self.clear_spectrum(h)
        self.set_acctime(h,acctime)
        self.enable_MCA(h)
        pass
    
    def read_sweep_spec_clear(self,h=None):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.PID1,pam.PID2=int(2),int(1)#request spectrum
        pam.PID1,pam.PID2=int(2),int(2)#request & clear spectrum
        pam.PID1,pam.PID2=int(2),int(3)#request spectrum & status
        pam.PID1,pam.PID2=int(2),int(4)#request &clear spectrum & status
        pam=self.calc_checksum(pam)
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent with bytes '+str(bytesWritten)
        else:
            print( 'Package sent failed')
        bytesWritten=ctypes.c_ulong(0)
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Data read' 
        else:
            print ('Spectrum read failed')
        statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
        raw=np.asarray(statdata[0:len(statdata)-64])
        rspec=(raw[np.arange(self.nchan)*3]+raw[np.arange(self.nchan)*3+1]*256+raw[np.arange(self.nchan)*3+2]*256*256)
        sts=self.PD5Status(statdata[-64:])
        print( sts.Acctime, sts.Realtime, rspec.sum())
        return rspec,statdata[-64:]
        pass

    def read_sweep_spec(self,h=None):
        if h ==None:
            h=self.cc_connect.h
        pam=self.Packet_MA()
        pam.PID1,pam.PID2=int(2),int(1)#request spectrum
        pam.PID1,pam.PID2=int(2),int(2)#request & clear spectrum
        pam.PID1,pam.PID2=int(2),int(4)#request &clear spectrum & status
        pam.PID1,pam.PID2=int(2),int(3)#request spectrum & status
        pam=self.calc_checksum(pam)
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent with bytes '+str(bytesWritten)
        else:
            print( 'Package sent failed')
        bytesWritten=ctypes.c_ulong(0)
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Data read' 
        else:
            print( 'Spectrum read failed')
        statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
        raw=np.asarray(statdata[0:len(statdata)-64])
        rspec=(raw[np.arange(self.nchan)*3]+raw[np.arange(self.nchan)*3+1]*256+raw[np.arange(self.nchan)*3+2]*256*256)
        sts=self.PD5Status(statdata[-64:])
        print( sts.Acctime, sts.Realtime, rspec.sum()/sts.Realtime)
        return rspec,statdata[-64:]
        pass

    
    def end_sweep(self,h=None):
        if h ==None:
            h=self.cc_connect.h
        self.disable_MCA(h)
        self.clear_spectrum(h)
        pass


    def test_sweep(self,h=None):        
        if h ==None:
            h=self.cc_connect.h
        wait_time=.05
        res=np.zeros((100,2048))
        stat=np.zeros((100,64),dtype=int)        
        self.start_sweep(h)
        for i in range(100):
            time.sleep(wait_time)
            res[i,:],stat[i,:]=self.read_sweep_spec_clear()    
        self.end_sweep()
        return res,stat


    def test_sweep_nc(self,h=None):        
        if h ==None:
            h=self.cc_connect.h
        wait_time=.05
        res=np.zeros((100,2048))
        stat=np.zeros((100,64),dtype=int)        
        self.start_sweep(h)
        for i in range(100):
            time.sleep(wait_time)
            res[i,:],stat[i,:]=self.read_sweep_spec()    
        self.end_sweep()
        res[1:,:]=res[1:,:]-res[:-1,:]
        return res,stat
    
    def acc_spec(self,h=None, mtime=1, display=None, silent=False):
        print( h)
        if h ==None:
            h=self.cc_connect.h
        print( h,self.cc_connect.h)
        self.disable_MCA(h)
        self.clear_spectrum(h)
        self.set_acctime(h,mtime)
        self.enable_MCA(h)
        wait_time=mtime/20.
        if wait_time<.2:wait_time=.2 
        if wait_time>2.:wait_time=2. 
        st=self.status(h)
        start_time=time.time()
        print( wait_time)
        while st.Preset_RT_reached !=True:
            st=self.status(h)
            if silent != True: 
                print( time.time()-start_time,st.Realtime)
            time.sleep(wait_time)
            if time.time()-start_time > mtime*1.2:
                break
        pam=self.Packet_MA()
        pam.PID1,pam.PID2=int(2),int(1)#request spectrum
        pam.PID1,pam.PID2=int(2),int(2)#request & clear spectrum
        pam.PID1,pam.PID2=int(2),int(3)#request spectrum & status
        pam.PID1,pam.PID2=int(2),int(4)#request &clear spectrum & status
        pam=self.calc_checksum(pam)
        PLen = (pam.LENMSB * 256) + pam.LENLSB + 8
        bytesWritten=ctypes.c_ulong(0)
        if ctypes.windll.winusb.WinUsb_WritePipe(h.value, ctypes.c_ubyte(2), ctypes.byref(pam), ctypes.c_ulong(PLen), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Package sent with bytes '+str(bytesWritten)
        else:
            print ('Package sent failed')
        bytesWritten=ctypes.c_ulong(0)
        par=self.Packet_MA_in()
        if ctypes.windll.winusb.WinUsb_ReadPipe(h.value, ctypes.c_ubyte(129), ctypes.byref(par), ctypes.c_ulong(32767), ctypes.byref(bytesWritten), ctypes.c_void_p(0)):
            pass
            #print 'Data read' 
        else:
            print( 'Spectrum read failed')
#        return par
        statdata=par.DATA[:self.combineints((par.LENLSB,par.LENMSB))]
        raw=np.asarray(statdata[0:len(statdata)-64])
        rspec=(raw[np.arange(self.nchan)*3]+raw[np.arange(self.nchan)*3+1]*256+raw[np.arange(self.nchan)*3+2]*256*256)
        sts=self.PD5Status(statdata[-64:])
        print( sts.Acctime, sts.Realtime, rspec.sum())
        return rspec,statdata[-64:]
    
    
    def shutdown(self,h=None,winUSBHandle=None):
        if h ==None:
            h=self.cc_connect.h
        if winUSBHandle ==None:
            winUSBHandle=self.cc_connect.winUSBHandle
        #Close the connection
        if h !=None:
            if ctypes.windll.winusb.WinUsb_Free(h.value):
                print( 'USB handle freed')
            else:
                print( 'Free USB handle failed')
        else:
            print( 'h not given')
        if winUSBHandle !=None:
            if ctypes.windll.kernel32.CloseHandle(winUSBHandle) != 0:
                print( 'USB Handle closed')
            else:
                print( 'Closing USB Handle failed')
        else:
            print( 'winUSBHandle not given')
        


# dec=Amptek_SDD()
# dec.connect()
# dec.read_config()
# dec.status()
# dec.acc_spec()
# #dec.set_acctime(time=3)
# dec.start_sweep(acctime=3)

# st=time.time()
# spe=[]
# for i in range(10):
#     time.sleep(.5)
#     spe.append(dec.read_sweep_spec())
#     print(time.time()-st)


#dec.shutdown()
    
    


