# -*- coding: utf-8 -*-
"""
Created on Mon Aug 10 10:53:57 2015

@author: Matthias
"""

import sys
sys.path.append(r'C:\Users\Matthias\Documents\Paris\scanner')
sys.path.append(r'C:\Users\Public\xrf_scanner')
#import scanner_pipython as scanner
import thorlabs_wrapper as Thorlabs_Motor 
import Luis_Code
import amptek
import h5py
import numpy as np
import time
import matplotlib.pyplot as plt
import threading
import glob


class dummy_motor_class():
    def __init__(self, ident = None,SN=None):
        self.ident = ident
        self.name='Dummy motor'
        self.posi=100.
        self.nchan=2048
    def amov(self,pos):
        #        print 'dummy moved to '+str(pos)
#        time.sleep(.1)
        self.posi=pos
    def shutdown(self):
        print('dummy shut down')
    def pos(self,a=None,b=None,c=None,d=None):
        return self.posi
    def gvel(self):
        return 5.
    def svel(self,a=None,b=None,c=None,d=None):
        pass
    def amov_nowait(self,a=None,b=None,c=None,d=None):
        pass
    def connect_motor(self,a=None,b=None,c=None,d=None):
        pass
    def init_motor(self,a=None,b=None,c=None,d=None):
        pass        
    def reference_motor(self,a=None,b=None,c=None,d=None):
        pass
    
# def func(self,**kwargs):
#     self.a=kwargs.pop('a',"Default_a")
#     self.b=kwargs.pop('b',"Default_b")
#     if(kwargs):  
#       from: https://stackoverflow.com/questions/9862945/deal-with-undefined-arguments-more-elegantly


class dummy_detector_class():
    def __init__(self, ident = None,SN=None):
        self.ident = ident
        self.nchan=2048
        self.name='Dummy detector'
    def acc_spec(self,h=None,mtime=1):
        time.sleep(mtime)
#        print 'dummy acquired spectrum '
        return np.random.random(2048)*np.arange(2048),np.zeros(64)
    def shutdown(self):
        print('dummy shut down')
    def start_sweep(self, acctime=None):
        print('dummy started sweep')
    def connect(self):
        print('Dummy detector connected')
        return True
    def read_sweep_spec_clear(self,h=None):
        return np.random.random(2048)*np.arange(2048),np.zeros(64)
    def read_sweep_spec(self):
        return np.random.random(2048)*np.arange(2048),np.zeros(64)
    pass

class devices(object):
    def __init__(self,detec_o=dummy_detector_class,motor_o=dummy_motor_class,SNlist=['0115500249','0115500164']):
#        SNlist[0]='0155500850'
#        SNlist[1]='dummy'        
        self.detector=detec_o()
#        self.detector=dummy_detector_class()
        if not self.detector.connect():
            self.detector=dummy_detector_class()
            print('Using Dummy detector')
        try:
            self.motor1=motor_o(SN='0')
            #This is the old code for Pi Motors
            SNlist_info=self.motor1.dll.EnumerateUSB(self.motor1.mem)
            print('Connected motors: ')
            for m in SNlist_info:
                print(m)
        except:
            pass
        self.motor1=motor_o(SN=SNlist[0])
        self.motor2=motor_o(SN=SNlist[1])
        print(self.motor1.ident,self.motor2.ident)
        if not self.motor1.connect_motor():
            self.motor1=dummy_motor_class()
            print('Using Dummy for Motor 1')
        else:
            self.motor1.init_motor()
            self.motor1.reference_motor()
        if not self.motor2.connect_motor():
            self.motor2=dummy_motor_class()
            print('Using Dummy for Motor 2')
        else:
            self.motor2.init_motor()
            self.motor2.reference_motor()
        
        if len(SNlist) >2:
            self.motor3=motor_o(SN=SNlist[2])
            if not self.motor3.connect_motor():
                self.motor3=dummy_motor_class()
                print('Using Dummy for Motor 3')
            else:
                self.motor3.init_motor()
                self.motor3.reference_motor()
    

class monitor_scan(threading.Thread):
    def __init__(self, scan_to_watch, main_window):
        threading.Thread.__init__(self)
        self.scan_to_watch=scan_to_watch
        self.main_window=main_window
        
    def run(self):
        explict=False
        while self.scan_to_watch.is_alive():
            if explict:
                print('I AM WORLING!!!!!!!!!!!!!!!!!!XXXXXXXXXXXXXXXXXXXXXXXXXXXX')
            time.sleep(1)
            self.main_window.actionUpdateposition()

            imts=self.scan_to_watch.onlineimage
            wo=np.where(imts==0)
            wo2=np.where(imts!=0)
            if wo2[0].size != 0 and wo2[1].size != 0:
                imts[wo[0],wo[1]]=np.min(imts[wo2[0],wo2[1]])
            else:
                imts[:,:]=.1                
            tp_mean=self.scan_to_watch.sumspe/self.scan_to_watch.pix_n
            tp_max=self.scan_to_watch.maxspe
            mimi=.1#np.min([tp_mean,tp_max])
            try:
                tp_mean[np.where(tp_mean == 0)]=mimi
                tp_max[np.where(tp_max == 0)]=mimi
                if len(imts.shape) == 3:
                    imts=np.transpose(imts,[1,0,2])
                else:
                    imts=imts.T
                imts=(imts-imts.min())/(imts.max()-imts.min())
                exe=[self.scan_to_watch.xpos.min(),self.scan_to_watch.xpos.max(),self.scan_to_watch.ypos.min(),self.scan_to_watch.ypos.max()]
                self.main_window.online_image_widget.mplwidget.imshow(imts,extent=exe,aspect=1,interpolation='none')
                #imshow also accepts [...,...,3]
                self.main_window.online_image_widget.draw()            
            except:
                print('Some trouble with updating')

            try:
                self.main_window.online_spectrum_widget.mplwidget.clear()
                self.main_window.online_spectrum_widget.mplwidget.plot(tp_max,color='red')
                self.main_window.online_spectrum_widget.mplwidget.plot(tp_mean,color='blue')
                self.main_window.online_spectrum_widget.mplwidget.axes.set_yscale(u'log')#.yaxis._set_scale('log')
                self.main_window.online_spectrum_widget.draw()
            except:
                print('Some trouble with updating')


def spec2pix(spectrum):
    mode='Whisper'
    answer=np.zeros(3)
    if mode == 'Whisper':
        x=np.arange(spectrum.shape[0])
        pos=[.25*spectrum.shape[0],.5*spectrum.shape[0],.75*spectrum.shape[0]]
        fwhm=33*spectrum.shape[0]
        prof=np.zeros((3,spectrum.shape[0]))
        for i in range(3):
            prof[i,:]=np.e**(-1*(x-pos[i])**2/fwhm)
        regu=prof.sum(0)
        for i in range(3):
            prof[i,:]=prof[i,:]/regu
        prof[np.isnan(prof)]=0
        prof[np.isinf(prof)]=0
        for i in range(3):
            answer[i]=np.sum(spectrum*prof[i,:])        
    else:
        for i in range(3):
            answer[i]=np.sum(spectrum)
    return answer



class point_measure(threading.Thread):
    def __init__(self,
        detector=None,
        inner_motor=None,
        outer_motor=None,
        inner_start=None,
        inner_range=None,
        inner_step=None,
        outer_start=None,
        outer_range=None,
        outer_step=None,
        dwell_time=None,
        save_file=r'C:\data\TEMP\test.h5',
        Main_Window=None
        ):
            threading.Thread.__init__(self)
            if detector == None or inner_motor == None or outer_motor == None or inner_start == None or inner_range == None or inner_step == None or outer_start == None or outer_range == None or outer_step == None or dwell_time == None or save_file == None or Main_Window == None:
                    print('Not all needed parameters given!')
                    return
            self.xpos=np.arange(inner_start,inner_start+inner_range,inner_step)
            self.ypos=np.arange(outer_start,outer_start+outer_range,outer_step)        
            self.inner_motor=inner_motor
            self.outer_motor=outer_motor
            gof=1
            sf=0
            while gof != 0:
                self.save_file=save_file[:-3]+'_'+str(sf)+'.spe'
                gof=len(glob.glob(self.save_file))
                sf+=1
                if sf >=100:
                    return
            self.detector=detector
            self.dwell_time=dwell_time
            self.onlineimage=None
            self.sumspe=np.zeros(self.detector.nchan)
            self.maxspe=np.zeros(self.detector.nchan)
            self.Pause_man=False
            self.Stop_man=False
            self.Main_Window=Main_Window
            
    def run(self):            
        explict=False
        try:
            write_spe(self.save_file,np.zeros(4096))
        except:
            print('Failed writing spe file '+self.save_file)
            return
        self.onlineimage=np.zeros((len(self.xpos),len(self.ypos),3))
        st=time.time()
        self.pix_n=1
        self.detector.start_sweep(acctime=self.dwell_time)            
        self.isAlive=True
        while time.time()-st < self.dwell_time:
            print(time.time()-st , self.dwell_time)
            if self.Stop_man:
                break
            time.sleep(.5)
            spectrum,status=self.detector.read_sweep_spec_clear(h=None)
            self.sumspe=self.maxspe=spectrum
            if hasattr(self.detector, 'PD5Status'):
                stat=self.detector.PD5Status(status)
                if not stat.mca_enabled:
                    break
        if hasattr(self.detector, 'PD5Status'):
            stat=self.detector.PD5Status(status)
            tts=[stat.Acctime,stat.Realtime]
        else:
            tts=[0.,0.]
        write_spe(self.save_file,spectrum,tts,str(self.Main_Window.commentbox.toPlainText()))
        print('Done, results saved in '+self.save_file)
        print('it took: ', time.time()-st)
        self.isAlive=False


def write_spe(sfile=r'C:\Users\Public\xrf_scanner\test.spe',data=None,timera=[0.,0.],comment=''):
    try:
        f=open(sfile,'w')
    except:
        print('bad file name for spectrum')
        return
    if comment != '':
        f.write('$ COMMENT:\n')
        if type(comment) == type(''):
            f.write(comment+'\n')
        if type(comment) == type([]):
            for k in comment:
                f.write(k+'\n')
    f.write('$ TIME:\n')
    f.write(str(timera[0])+' '+str(timera[1])+'\n')
    f.write('$ DATA:\n')
    f.write('1   '+str(data.shape[0])+'\n')
    np.savetxt(f,data)
    f.close()
            
class step_scan(threading.Thread):
    def __init__(self,
        detector=None,
        inner_motor=None,
        outer_motor=None,
        inner_start=None,
        inner_range=None,
        inner_step=None,
        outer_start=None,
        outer_range=None,
        outer_step=None,
        dwell_time=None,
        save_file=r'C:\data\TEMP\test.h5',
        Main_Window=None
        ):
            threading.Thread.__init__(self)
            if detector == None or inner_motor == None or outer_motor == None or inner_start == None or inner_range == None or inner_step == None or outer_start == None or outer_range == None or outer_step == None or dwell_time == None or save_file == None or Main_Window == None:
                    print('Not all needed parameters given!')
                    return
            self.xpos=np.arange(inner_start,inner_start+inner_range,inner_step)
            self.ypos=np.arange(outer_start,outer_start+outer_range,outer_step)        
            self.save_file=save_file     
            self.detector=detector
            self.inner_motor=inner_motor
            self.outer_motor=outer_motor
            self.dwell_time=dwell_time
            self.onlineimage=None
            self.sumspe=np.zeros(self.detector.nchan)
            self.maxspe=np.zeros(self.detector.nchan)
            self.Pause_man=False
            self.Stop_man=False
            self.Main_Window=Main_Window
            
    def run(self):            
        explict=False
        self.onlineimage=np.zeros((len(self.xpos),len(self.ypos),3))
        st=time.time()
        self.pix_n=0
        self.isAlive=True
        for yn,yp in enumerate(self.ypos):
            self.outer_motor.amov(yp)
            self.xpos=self.xpos[::-1]
            xnum=self.xpos.argsort()
            if self.Stop_man:
                break
            if not self.Main_Window.allow_move:
                break
            try:
                save_filename=str(self.save_file)
                save_filename=save_filename[:save_filename.rfind('.')]+'_'+str(yn).zfill(5)+'.h5'
                sf=h5py.File(save_filename, 'w')
                sf.create_dataset('spectra',(len(self.xpos),1,self.detector.nchan))#detector.nchan))#,dtype='l')
                sf.create_dataset('status',(len(self.xpos),1,64),dtype='l')
                sf.create_dataset('position',(len(self.xpos),1,3))
                sf['comments']=str(self.Main_Window.commentbox.toPlainText())
            except:
                print('Failed opening H5 file')
                return
            for i in range(len((self.xpos))):
                xp=self.xpos[i]
                xn=xnum[i]
                if explict:
                    print(xn, yn, xp, yp)
                self.inner_motor.amov(xp)
                spectrum,status=self.detector.acc_spec(h=None,mtime=self.dwell_time)
                sf['spectra'][xn,0,:]=spectrum
                sf['status'][xn,0,:]=status
                sf['position'][xn,0,:]=xp,yp,time.time()-st
                self.onlineimage[xn,yn,:]=spec2pix(spectrum)
                self.sumspe+=spectrum
                self.maxspe[self.maxspe<spectrum]=spectrum[self.maxspe<spectrum]
                self.pix_n+=1
                if explict:
                    print(sum(self.sumspe),sum(self.maxspe))
                if self.Pause_man:
                    print('Scan paused')
                    while self.Pause_man:
                        time.sleep(1.)
                if self.Stop_man:
                    break
                if not self.Main_Window.allow_move:
                    break
            sf.close()
            print(save_filename+' successfully written to disk')
        self.isAlive=False
        print('Done, results saved in '+self.save_file)
        print('it took: ', time.time()-st)
        print('it should have: ', len(self.xpos)*len(self.ypos)*self.dwell_time)
#            plt.show()


class step_scan_singlefile(threading.Thread):
    def __init__(self,
        detector=None,
        inner_motor=None,
        outer_motor=None,
        inner_start=None,
        inner_range=None,
        inner_step=None,
        outer_start=None,
        outer_range=None,
        outer_step=None,
        dwell_time=None,
        save_file=r'C:\data\TEMP\test.h5',
        Main_Window=None
        ):
            threading.Thread.__init__(self)
            if detector == None or inner_motor == None or outer_motor == None or inner_start == None or inner_range == None or inner_step == None or outer_start == None or outer_range == None or outer_step == None or dwell_time == None or save_file == None or Main_Window == None:
                    print('Not all needed parameters given!')
                    return
            self.xpos=np.arange(inner_start,inner_start+inner_range,inner_step)
            self.ypos=np.arange(outer_start,outer_start+outer_range,outer_step)        
            self.save_file=save_file     
            self.detector=detector
            self.inner_motor=inner_motor
            self.outer_motor=outer_motor
            self.dwell_time=dwell_time
            self.onlineimage=None
            self.sumspe=np.zeros(self.detector.nchan)
            self.maxspe=np.zeros(self.detector.nchan)
            self.Pause_man=False
            self.Stop_man=False
            self.Main_Window=Main_Window
            
    def run(self):            
        explict=False
        try:
            sf=h5py.File(str(self.save_file), 'w')
            sf.create_dataset('spectra',(len(self.xpos),len(self.ypos),self.detector.nchan))#detector.nchan))#,dtype='l')
            sf.create_dataset('status',(len(self.xpos),len(self.ypos),64),dtype='l')
            sf.create_dataset('position',(len(self.xpos),len(self.ypos),3))
            sf['comments']=str(self.Main_Window.commentbox.toPlainText())
        except:
            print('Failed opening H5 file')
            return
        self.onlineimage=np.zeros((len(self.xpos),len(self.ypos),3))
        st=time.time()
        self.pix_n=0
        self.isAlive=True
        for yn,yp in enumerate(self.ypos):
            self.outer_motor.amov(yp)
            self.xpos=self.xpos[::-1]
            xnum=self.xpos.argsort()
            if self.Stop_man:
                break
            if not self.Main_Window.allow_move:
                break
            for i in range(len((self.xpos))):
                xp=self.xpos[i]
                xn=xnum[i]
                if explict:
                    print(xn, yn, xp, yp)
                self.inner_motor.amov(xp)
                spectrum,status=self.detector.acc_spec(h=None,mtime=self.dwell_time)
                sf['spectra'][xn,yn,:]=spectrum
                sf['status'][xn,yn,:]=status
                sf['position'][xn,yn,:]=xp,yp,time.time()-st
                self.onlineimage[xn,yn,:]=spec2pix(spectrum)
                self.sumspe+=spectrum
                self.maxspe[self.maxspe<spectrum]=spectrum[self.maxspe<spectrum]
                self.pix_n+=1
                if explict:
                    print(sum(self.sumspe),sum(self.maxspe))
                if self.Pause_man:
                    print('Scan paused')
                    while self.Pause_man:
                        time.sleep(1.)
                if self.Stop_man:
                    break
                if not self.Main_Window.allow_move:
                    break
        sf.close()
        self.isAlive=False
        print('Done, results saved in '+self.save_file)
        print('it took: ', time.time()-st)
        print('it should have: ', len(self.xpos)*len(self.ypos)*self.dwell_time)
#            plt.show()


class dynamic_scan(threading.Thread):#This is the new multi-line version of the class
    def __init__(self,
        detector=None,
        inner_motor=None,
        outer_motor=None,
        inner_start=None,
        inner_range=None,
        inner_step=None,
        outer_start=None,
        outer_range=None,
        outer_step=None,
        dwell_time=None,
        save_file=r'C:\data\TEMP\test.h5',
        Main_Window=None
        ):
            threading.Thread.__init__(self)
            if detector == None or inner_motor == None or outer_motor == None or inner_start == None or inner_range == None or inner_step == None or outer_start == None or outer_range == None or outer_step == None or dwell_time == None or save_file == None or Main_Window == None:
                    print('Not all needed parameters given!')
                    return
            self.xpos=np.arange(inner_start,inner_start+inner_range,inner_step)
            self.ypos=np.arange(outer_start,outer_start+outer_range,outer_step)        
            self.save_file=save_file     
            self.detector=detector
            self.inner_motor=inner_motor
            self.outer_motor=outer_motor
            self.dwell_time=dwell_time
            self.onlineimage=None
            self.sumspe=np.zeros(self.detector.nchan)
            self.maxspe=np.zeros(self.detector.nchan)
            self.Pause_man=False
            self.Stop_man=False
            self.time_offset=.01    
            self.vel=inner_step/(dwell_time+self.time_offset)
            self.save_file=save_file
            self.Main_Window=Main_Window
            self.isAlive=False
            
    def run(self):            
        explict=False
        self.onlineimage=np.zeros((len(self.xpos),len(self.ypos),3))
        
        st=time.time()
        self.pix_n=0
        self.oldvel=self.inner_motor.gvel()
        self.inner_motor.svel(self.vel)
        self.isAlive=True        
#        self.inner_motor.svel()
        for yn,yp in enumerate(self.ypos):
            if self.Pause_man:
                print('Scan paused')
                while self.Pause_man:
                    time.sleep(1.)
            if self.Stop_man:
                break
            if not self.Main_Window.allow_move:
                print('breqking due to motor stop')
                break
            try:
                save_filename=str(self.save_file)
                save_filename=save_filename[:save_filename.rfind('.')]+'_'+str(yn).zfill(5)+'.h5'
                sf=h5py.File(save_filename, 'w')
                sf.create_dataset('spectra',(len(self.xpos),1,self.detector.nchan))#detector.nchan))#,dtype='l')
                sf.create_dataset('status',(len(self.xpos),1,64),dtype='l')
                sf.create_dataset('position',(len(self.xpos),1,5))
                sf['comments']=str(self.Main_Window.commentbox.toPlainText())
            except:
                print('Failed opening H5 file')
                return

            self.outer_motor.amov(yp)
            print('gave order to outer motor')
            self.xpos=self.xpos[::-1]
            #Experimental Offset
            
            xoffset=0
            if self.xpos[1]-self.xpos[0] < 0:
                xoffset=-1*(self.xpos[1]-self.xpos[0])
            self.inner_motor.amov(self.xpos[0]+xoffset)
            print('gave order to inner motor')
            xnum=self.xpos.argsort()
            time_arr=(np.arange(len(self.xpos))+1)*(self.dwell_time+self.time_offset)
            stl=time.time()
            self.detector.start_sweep(acctime=self.dwell_time)            
            self.inner_motor.amov_nowait(self.xpos[-1]+self.xpos[2]-self.xpos[0])
            print('gave order to inner motor for sweep')
            for i in range(len(time_arr)):
                ts=time_arr[i]-time.time()+stl
                if ts<0:
                    ts=0
                tp=time.time()-st
                time.sleep(ts)
                xn=xnum[i]
#                xp=self.inner_motor.pos()
                xp=0.
                if explict:
                    print(xn, yn, xp, yp)
                spectrum,status=self.detector.read_sweep_spec_clear(h=None)
                tp2=time.time()-st
                sf['spectra'][xn,0,:]=spectrum
                sf['status'][xn,0,:]=status
#                sf['position'][xn,0,:]=xp,self.xpos[i],self.outer_motor.pos(),yp,tp
                sf['position'][xn,0,:]=xp,self.xpos[i],tp2,yp,tp
                self.onlineimage[xn,yn,:]=spec2pix(spectrum)
                self.sumspe+=spectrum
                self.maxspe[self.maxspe<spectrum]=spectrum[self.maxspe<spectrum]
                self.pix_n+=1
                if not self.Main_Window.allow_move:
                    print('breaking due to motor stop')
                    break
                if explict:
                    print(sum(self.sumspe),sum(self.maxspe))
            sf.close()
            print(save_filename+' successfully written to disk')
        self.isAlive=False
        self.inner_motor.svel(self.oldvel)
        print('Done, results saved in '+self.save_file)
        print( 'it took: ', time.time()-st)
        print( 'it should have: ', len(self.xpos)*len(self.ypos)*(self.dwell_time+self.time_offset))
#            plt.show()

class dynamic_scan_onefile(threading.Thread):
    def __init__(self,
        detector=None,
        inner_motor=None,
        outer_motor=None,
        inner_start=None,
        inner_range=None,
        inner_step=None,
        outer_start=None,
        outer_range=None,
        outer_step=None,
        dwell_time=None,
        save_file=r'C:\data\TEMP\test.h5',
        Main_Window=None
        ):
            threading.Thread.__init__(self)
            if detector == None or inner_motor == None or outer_motor == None or inner_start == None or inner_range == None or inner_step == None or outer_start == None or outer_range == None or outer_step == None or dwell_time == None or save_file == None or Main_Window == None:
                    print('Not all needed parameters given!')
                    return
            self.xpos=np.arange(inner_start,inner_start+inner_range,inner_step)
            self.ypos=np.arange(outer_start,outer_start+outer_range,outer_step)        
            self.save_file=save_file     
            self.detector=detector
            self.inner_motor=inner_motor
            self.outer_motor=outer_motor
            self.dwell_time=dwell_time
            self.onlineimage=None
            self.sumspe=np.zeros(self.detector.nchan)
            self.maxspe=np.zeros(self.detector.nchan)
            self.Pause_man=False
            self.Stop_man=False
            self.time_offset=.01    
            self.vel=inner_step/(dwell_time+self.time_offset)
            self.save_file=save_file
            self.Main_Window=Main_Window
            self.isAlive=False
            
    def run(self):            
        explict=False
        try:
            sf=h5py.File(str(self.save_file), 'w')
            sf.create_dataset('spectra',(len(self.xpos),len(self.ypos),self.detector.nchan))#detector.nchan))#,dtype='l')
            sf.create_dataset('status',(len(self.xpos),len(self.ypos),64),dtype='l')
            sf.create_dataset('position',(len(self.xpos),len(self.ypos),5))
            sf['comments']=str(self.Main_Window.commentbox.toPlainText())
        except:
            print('Failed opening H5 file')
            return
        self.onlineimage=np.zeros((len(self.xpos),len(self.ypos),3))
        
        st=time.time()
        self.pix_n=0
        self.oldvel=self.inner_motor.gvel()
        self.inner_motor.svel(self.vel)
        self.isAlive=True        
#        self.inner_motor.svel()
        for yn,yp in enumerate(self.ypos):
            if self.Pause_man:
                print('Scan paused')
                while self.Pause_man:
                    time.sleep(1.)
            if self.Stop_man:
                break
            if not self.Main_Window.allow_move:
                print('breqking due to motor stop')
                break
            self.outer_motor.amov(yp)
            print('gave order to outer motor')
            self.xpos=self.xpos[::-1]
            #Experimental Offset
            
            xoffset=0
            if self.xpos[1]-self.xpos[0] < 0:
                xoffset=-1*(self.xpos[1]-self.xpos[0])
            self.inner_motor.amov(self.xpos[0]+xoffset)
            print('gave order to inner motor')
            xnum=self.xpos.argsort()
            time_arr=(np.arange(len(self.xpos))+1)*(self.dwell_time+self.time_offset)
            stl=time.time()
            self.detector.start_sweep(acctime=self.dwell_time)            
            self.inner_motor.amov_nowait(self.xpos[-1]+self.xpos[2]-self.xpos[0])
            print('gave order to inner motor for sweep')
            for i in range(len(time_arr)):
                ts=time_arr[i]-time.time()+stl
                if ts<0:
                    ts=0
                tp=time.time()-st
                time.sleep(ts)
                xn=xnum[i]
                xp=self.inner_motor.pos()
                if explict:
                    print(xn, yn, xp, yp)
                spectrum,status=self.detector.read_sweep_spec_clear(h=None)
                sf['spectra'][xn,yn,:]=spectrum
                sf['status'][xn,yn,:]=status
                sf['position'][xn,yn,:]=xp,self.xpos[i],self.outer_motor.pos(),yp,tp
                self.onlineimage[xn,yn,:]=spec2pix(spectrum)
                self.sumspe+=spectrum
                self.maxspe[self.maxspe<spectrum]=spectrum[self.maxspe<spectrum]
                self.pix_n+=1
                if not self.Main_Window.allow_move:
                    print('breaking due to motor stop')
                    break
                if explict:
                    print(sum(self.sumspe),sum(self.maxspe))
        sf.close()
        self.isAlive=False
        self.inner_motor.svel(self.oldvel)
        print('Done, results saved in '+self.save_file)
        print( 'it took: ', time.time()-st)
        print( 'it should have: ', len(self.xpos)*len(self.ypos)*(self.dwell_time+self.time_offset))
#            plt.show()

def master():
    detsel='Amptek_SDD'
    detsel='dummy'
#    if detsel == 'Amptek_SDD':
#        detector=amptek.Amptek_SDD()
#        detector.connect()
    if detsel == 'dummy':
        detector=dummy_detector_class()
    motsel='one_dummy'
    motsel='dummy'
    if motsel =='dummy':
        motor1=dummy_motor_class()
        motor2=dummy_motor_class()
#    if motsel =='one_dummy':
#        motor1=scanner.PI_Motor()
#        motor1.connect_motor()
#        motor1.init_motor()
#        motor1.reference_motor()
#        motor2=dummy_motor_class()
    step_scan_fun(detector,motor1,motor2,100,10,.1,2,12,.1,1.)
    detector.shutdown()
    motor1.shutdown()
    motor2.shutdown()
    
def step_scan_fun(
    detector=None,
    inner_motor=None,
    outer_motor=None,
    inner_start=None,
    inner_range=None,
    inner_step=None,
    outer_start=None,
    outer_range=None,
    outer_step=None,
    dwell_time=None,
    save_file=r'C:\data\TEMP\test.h5'
    ):
        xpos=np.arange(inner_start,inner_start+inner_range,inner_step)
        ypos=np.arange(outer_start,outer_start+outer_range,outer_step)        
        sf=h5py.File(save_file, 'w')
        sf.create_dataset('spectra',(len(xpos),len(ypos),2048))#detector.nchan))#,dtype='l')
        sf.create_dataset('status',(len(xpos),len(ypos),64),dtype='l')
        sf.create_dataset('position',(len(xpos),len(ypos),2))
        st=time.time()
        for yn,yp in enumerate(ypos):
            outer_motor.amov(yp)
            xpos=xpos[::-1]
            xnum=xpos.argsort()
            for i in range(len((xpos))):
                xp=xpos[i]
                xn=xnum[i]
                print( xn, yn, xp, yp)
                inner_motor.amov(xp)
                spectrum,status=detector.acc_spec(h=None,mtime=dwell_time)
                sf['spectra'][xn,yn,:]=spectrum
                sf['status'][xn,yn,:]=status
                sf['position'][xn,yn,:]=xp,yp
#                print spectrum.mean(), np.mean(sf['spectra'][xn,yn,:])
        data=np.asarray(sf['spectra'][:,:,:])
        plt.imshow(data[:,:,:].sum(2))
        sf.close()
        print( 'Done, results saved in '+save_file)
        print( 'it took: ', time.time()-st)
        print ('it should have: ', len(xpos)*len(ypos)*dwell_time)
        plt.show()
            
#master()