# -*- coding: utf-8 -*-
"""
Created on Fri May 22 17:32:36 2015

@author: Matthias
"""
import ctypes
import time
    
class PI_Motor():
    #Definition of functions
    def __init__(self, ident = None, SN=None):
        self.ident = ident
        if SN == None:
            self.SN='0115500164'
        else:
            self.SN=SN
        self.dll=ctypes.windll.PI_GCS2_DLL

    def connect_motor(self):
        self.ID=self.dll.PI_ConnectUSB(ctypes.c_char_p(self.SN))
        if self.ID<0:
            print("Could not connect to "+self.SN)
            return False
        buff=ctypes.c_buffer('',255)
        idn=self.dll.PI_qIDN(ctypes.c_int(self.ID),buff,255)
        print('Connected to '+buff.value)
        
        buff=ctypes.c_buffer('',255)
        idn=self.dll.PI_qVER(ctypes.c_int(self.ID),buff,255)
        print('With parameters '+buff.value)
        return self.ID
        
    def init_motor(self,stage='M-403.8PD'):
        if self.ID == None:
            return
        buff=ctypes.c_buffer('',255)
        self.dll.PI_qCST(ctypes.c_int(self.ID),ctypes.c_char_p('1'),buff,255)
        print(buff.value)
        td=buff.value
        td=td[td.find('=')+1:td.find('\n')]
        print(td)
        if td != 'DEFAULT_STAGE':
            print('Connected to '+td)
            return
        st=self.dll.PI_CST(ctypes.c_int(self.ID),(ctypes.c_char_p('1')),(ctypes.c_char_p(stage)))
        buff=ctypes.c_buffer('',255)
        self.dll.PI_qCST(ctypes.c_int(self.ID),ctypes.c_char_p('1'),buff,255)
        td=buff.value
        td=td[td.find('=')+1:td.find('\n')]
        if st == 0:
            print('Motor set to '+td+' but was meant to be '+stage)
        #This is the moment to switch on the 
    
    def reference_motor(self):
        if self.ID == None:
            return
        isref=ctypes.c_bool()
        self.dll.PI_SVO(ctypes.c_int(self.ID),ctypes.c_char_p('1'),isref)
        if isref.value:
            print('Stage is referenced')
        else:
            st=self.dll.PI_FRF(ctypes.c_int(self.ID),ctypes.c_char_p('1'))  # is reference switch
    #        st=self.dll.PI_FPL(ctypes.c_int(self.ID),ctypes.c_char_p('1')) # is positive end switch
    #        st=self.dll.PI_FNL(ctypes.c_int(self.ID),ctypes.c_char_p('1')) # is negative end switch
            if st == 0:
                print('Axis properly referenced')
            else:
                print('Reference failed')
    
    def simple_scan(self):
        if self.ID == None:
            return
        startpos=ctypes.c_double(0.)
        self.dll.PI_qPOS(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(startpos))    
        for i in range(10):
            self.dll.PI_MOV(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(ctypes.c_double(startpos.value+i)))
            ismoving=ctypes.c_bool(True)
            self.dll.PI_IsMoving(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(ismoving))
            while ismoving.value:
                time.sleep(.1)
                self.dll.PI_IsMoving(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(ismoving))
            spot=ctypes.c_double(0.)
            self.dll.PI_qPOS(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(spot))    
            print('Measuring at '+str(spot.value))
            time.sleep(1)
    
    def amov(self,dest):
        if self.ID == None:
            return
        ismoving=ctypes.c_bool(True)
        self.dll.PI_MOV(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(ctypes.c_double(dest)))
        self.dll.PI_IsMoving(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(ismoving))
        while ismoving.value:
            time.sleep(.01)
            self.dll.PI_IsMoving(ctypes.c_int(self.ID),ctypes.c_char_p('1'),ctypes.byref(ismoving))
    
    def shutdown(self,ID=None):
        if self.dll.PI_CloseConnection(self.ID):
            print('is shutdown')
        else:
            print('shutdown failed')
        

#ID=connect_motor(SN='0115500164')
#init_motor(ID=ID)
#reference_motor(ID=ID)
if __name__ == u'__main__':
    a=PI_Motor()
    a.connect_motor()
    a.init_motor()
    a.reference_motor()
    a.shutdown()

#def firts_tries_do_not_call():
#    dllfile='C:\\ProgramData\\PI\\GCSTranslator\\PI_GCS2_DLL.dll'
#    dll=ctypes.windll.PI_GCS2_DLL
#    
#    ID=dll[217](ctypes.c_char_p('0115500249'))
#    
#    err=dll[8](ctypes.c_int(ID))
#    error=ctypes.c_buffer('',size=1024)
#    dll[9](ctypes.c_int(err),error,1024)
#    print('ERROR is '+error.value
#    
#    buff=ctypes.c_buffer('',255)
#    idn=dll[11](ctypes.c_int(ID),buff,255)
#    print('ID '+buff.value
#    
#    buff=ctypes.c_buffer('',255)
#    idn=dll[158](ctypes.c_int(ID),buff,255)
#    print('ID '+buff.value
#    
#    buff=ctypes.c_buffer('',255)
#    idn=dll[35](ctypes.c_int(ID),buff,255)
#    print('number of motors '+buff.value
#    
#    tram=ctypes.c_double(2.)
#    dll[20](ctypes.c_int(ID),ctypes.c_char_p('1'),ctypes.byref(tram))
#    tram.value
#    
#    
#    tram=ctypes.c_bool(True)
#    dll[165](ctypes.c_int(ID),ctypes.c_char_p('1'),tram)
#    tram.value
#    
#    #this is the move command
#    dll[14]
#    
#    #to close:
#    dll[7](ctypes.c_int(ID))
#    ID=dll[217](ctypes.c_char_p('0115500249'))


#Convert spectrum to color:
#if w >= 380 and w < 440:
#    R = -(w - 440.) / (440. - 380.)
#    G = 0.0
#    B = 1.0
#elif w >= 440 and w < 490:
#    R = 0.0
#    G = (w - 440.) / (490. - 440.)
#    B = 1.0
#elif w >= 490 and w < 510:
#    R = 0.0
#    G = 1.0
#    B = -(w - 510.) / (510. - 490.)
#elif w >= 510 and w < 580:
#    R = (w - 510.) / (580. - 510.)
#    G = 1.0
#    B = 0.0
#elif w >= 580 and w < 645:
#    R = 1.0
#    G = -(w - 645.) / (645. - 580.)
#    B = 0.0
#elif w >= 645 and w <= 780:
#    R = 1.0
#    G = 0.0
#    B = 0.0
#else:
#    R = 0.0
#    G = 0.0
#    B = 0.0
#
#void spectral_color(double &r,double &g,double &b,double l) // RGB <0,1> <- lambda l <400,700> [nm]
#    {
#    double t;  r=0.0; g=0.0; b=0.0;
#         if ((l>=400.0)&&(l<410.0)) { t=(l-400.0)/(410.0-400.0); r=    +(0.33*t)-(0.20*t*t); }
#    else if ((l>=410.0)&&(l<475.0)) { t=(l-410.0)/(475.0-410.0); r=0.14         -(0.13*t*t); }
#    else if ((l>=545.0)&&(l<595.0)) { t=(l-545.0)/(595.0-545.0); r=    +(1.98*t)-(     t*t); }
#    else if ((l>=595.0)&&(l<650.0)) { t=(l-595.0)/(650.0-595.0); r=0.98+(0.06*t)-(0.40*t*t); }
#    else if ((l>=650.0)&&(l<700.0)) { t=(l-650.0)/(700.0-650.0); r=0.65-(0.84*t)+(0.20*t*t); }
#         if ((l>=415.0)&&(l<475.0)) { t=(l-415.0)/(475.0-415.0); g=             +(0.80*t*t); }
#    else if ((l>=475.0)&&(l<590.0)) { t=(l-475.0)/(590.0-475.0); g=0.8 +(0.76*t)-(0.80*t*t); }
#    else if ((l>=585.0)&&(l<639.0)) { t=(l-585.0)/(639.0-585.0); g=0.84-(0.84*t)           ; }
#         if ((l>=400.0)&&(l<475.0)) { t=(l-400.0)/(475.0-400.0); b=    +(2.20*t)-(1.50*t*t); }
#    else if ((l>=475.0)&&(l<560.0)) { t=(l-475.0)/(560.0-475.0); b=0.7 -(     t)+(0.30*t*t); }
#    }